Public Class Form1
    Private blnExit As Boolean ' Are we exiting

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Static itIcon As Short

        itIcon += 1
        Select Case itIcon
            Case 1 'Clicked Once
                'Set Error Icon
                NotifyIcon1.ShowBalloonTip(3000, "Demonstration", "This is a Test", ToolTipIcon.Error)

            Case 2 'Clicked Twice
                'Set Info Icon
                NotifyIcon1.ShowBalloonTip(3000, "Demonstration", "This is a Test", ToolTipIcon.Info)

            Case 3 'Clicked Three Times
                'Set Warning Icon
                NotifyIcon1.ShowBalloonTip(3000, "Demonstration", "This is a Test", ToolTipIcon.Warning)

            Case 4 'Clicked 4 Times
                'No Icon
                NotifyIcon1.ShowBalloonTip(3000, "Demonstration", "This is a Test", ToolTipIcon.None)

                itIcon = 0 'Start Over
        End Select

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        NotifyIcon1.BalloonTipText = "This is a test" 'Set Balloon Tip Text
        NotifyIcon1.ShowBalloonTip(4000) 'Display 4 Seconds
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        NotifyIcon1.BalloonTipTitle = "Demonstration" 'Set Title
        NotifyIcon1.ShowBalloonTip(5000) 'Display 5 seconds
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not blnExit Then
            e.Cancel = True 'If this is not set, the form WILL close!

            NotifyIcon1.Visible = True 'show icon
            WindowState = FormWindowState.Minimized 'minimise our form
            ShowInTaskbar = False 'remove form from taskbar
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        NotifyIcon1.Text = "Demonstration" & Environment.NewLine & "This is a test" 'Multiple Line ToolTip Text
        NotifyIcon1.Icon = New System.Drawing.Icon(Application.StartupPath & "\misc01.ico") 'Load icon
        NotifyIcon1.Visible = True 'Show
    End Sub

    Private Sub NotifyIcon1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.Click
        WindowState = FormWindowState.Normal 'show our form again
        NotifyIcon1.Visible = False 'hide the notify icon
        ShowInTaskbar = True 'show our form in the taskbar again
    End Sub

    Private Sub NotifyIcon1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Right Then 'If Right Clicked
            Timer1.Enabled = True
        Else 'Left
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        OpenFileDialog1.DefaultExt = ".ico"
        OpenFileDialog1.Filter = "*.ico|*.ico"

        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            NotifyIcon1.Icon = New Icon(OpenFileDialog1.FileName) 'Load New Icon From OFD

        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static imIndex As Short 'keeps track of current pic

        Select Case imIndex
            Case 0 'First Pic
                Dim bm As Bitmap = ImageList1.Images(0)
                NotifyIcon1.Icon = System.Drawing.Icon.FromHandle(bm.GetHicon) 'HIcon = Handle To Icon
            Case 1 'Second Pic
                Dim bm As Bitmap = ImageList1.Images(1)
                NotifyIcon1.Icon = System.Drawing.Icon.FromHandle(bm.GetHicon)
            Case 2 'Third Pic
                Dim bm As Bitmap = ImageList1.Images(2)
                NotifyIcon1.Icon = System.Drawing.Icon.FromHandle(bm.GetHicon)
            Case 3 'Fourth Pic
                Dim bm As Bitmap = ImageList1.Images(3)
                NotifyIcon1.Icon = System.Drawing.Icon.FromHandle(bm.GetHicon)
            Case 4 'Fifth Pic
                Dim bm As Bitmap = ImageList1.Images(4)
                NotifyIcon1.Icon = System.Drawing.Icon.FromHandle(bm.GetHicon)
                imIndex = 0 'Start Over
        End Select
        imIndex += 1
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        blnExit = True 'We are really closing
        Me.Close() 'exit
    End Sub
End Class
